/* ǡ monoral data Ф
 * 12/30 2003
 * shige
 * sndchan.c
 *
 * $Id: sndchan.c,v 1.3 2004-01-13 15:41:01+09 shige Exp $
 */
/* sndchan (-o [file]) -c[n] [file0]
 *  -c[n]: 
 *  -c1: left data  stdout (or [file])
 *  -c2: right data  stdout (or [file])
 * monaural data ξ error ?
 *
 * 1)	n=0 ʤ顢줾 file ̾ file 뤳ȤˤƤ⤤
 * 2)	sox Ǥ
 * 	     sox file.wav -c 1 hoge.wav pick -l (-r)
 *	ǤǤ롣
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

int main(int argc,char *argv[]);
int getarg(int argc,char **argv,int *ch,FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    SNDheader snd;
    int ch,ch0,format,blocks,bs,bps;
    int j,k,ret;
    
    if((ret=getarg(argc,argv,&ch,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if(ch==0){ usage(10); return 10; }  /* unsupported yet */
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Error: In getSNDheader(). (%d)\n",ret);
	return 20;
    }
    if((ch0=SNDchannels(&snd,format))<1 || ch<1 || ch>ch0){
	fprintf(stderr,"Specified channel=%d is not appropriate.\n",ch);
	fprintf(stderr,"Total channels: %d\n",ch0);
	return 40;
    }
    blocks=SNDblocks(&snd,format);
    bps=SNDbitpersmpl(&snd,format);
#ifdef DEBUG1
    fprintf(stderr,"(blocks,bps,ch0,ch)=(%d,%d,%d,%d)\n",blocks,bps,ch0,ch);
#endif
    putSNDheaderBlocksChannels(outfile,&snd,blocks,1,format);
    for(j=1;j<=blocks;j++)
      for(k=1;k<=ch0;k++)
	if(k!=ch) SNDskip1chdata(infile,&snd,format);
	else SNDreadput1chdata(infile,outfile,&snd,format);
    bs=SNDblocksize(&snd,format)/ch0;
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

int getarg(int argc,char **argv,int *ch,FILE **infile,FILE **outfile)
{
    *outfile=stdout;
    *infile=stdin;
    *ch=-1;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'c': 
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -1;
		    else argv++;
		}
		if((*ch=atoi(*argv))<0) return -2;
		break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -4;
		    else argv++;
		}
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc>1){
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n",argc);
#endif
	return -7;
    }
    if(*ch<0) return -8;
    if(argc<1) return 1;
    if(!strcmp(*argv,"-")) *infile=stdin;
    else if((*infile=fopen(*argv,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndchan (-o [outfile]) -c[n] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   -c[n]: [n] ͥܤΥǡ (ɬ)",
	"   [infile]: ϥե (ά: ɸ)",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
