/*
 * ʣβ file  block ¤٤
 * shige
 * 01/13 2004
 * 
 * $Id: sndconmix.c,v 1.1 2004-01-13 16:52:12+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

#define Maxchannel 10
#define Maxfiles 20

int main(int argc,char *argv[]);
void putheader(FILE *outfile,SNDheader *snd,long int blocks,int ch,int format,
	       int N);
void putoutconmix(FILE *infile[],FILE *outfile,SNDheader snd[],int format,
                  int putnums,double lv[],int dist[],int ch0,int N);
void put1blocks(FILE *infile,FILE *outfile,SNDheader *snd,int format,double lv,
                int ch0);
long int gettotalputnums(SNDheader snd[],int format,int dist[],int N);
int getchannel(SNDheader snd[],int format,int N);
int getallheader(FILE *infile[],SNDheader snd[],double lv[],int isv[],int N,
                 int mc);
double getmaxlevelCh(FILE *infile,SNDheader *snd,int format,int mc);
int getarg(int argc,char *argv[],FILE **outfile,FILE *infile[],int *mc,
          double lv[],int isv[],int dist[]);
void usage(int ret);

int main(int argc,char *argv[])
{
    SNDheader snd[Maxfiles];
    FILE *infile[Maxfiles],*outfile=stdout;
    double lv[Maxfiles+1];
    int isv[Maxfiles+1],dist[Maxfiles+1],dists,N,mc,format,ch0,j;
    long int putnums;

    if((N=getarg(argc,argv,&outfile,infile,&mc,lv,isv,dist))<=0){
	usage(N); return -N; 
    }
#ifdef DEBUG1
    {
	int j;
	for(j=1;j<=N;j++)
	  fprintf(stderr,"(lv,isv,dist)[%d]=(%f,%d,%d)\n",j-1,
		  lv[j-1],isv[j-1],dist[j-1]);
	return 0;
    }
#endif
    if((format=getallheader(infile,snd,lv,isv,N,mc))<0){ usage(N); return -N; }
    if(!mc) ch0=1;
    else if((ch0=getchannel(snd,format,N))<0){ usage(ch0); return -ch0; }
    dists=0;
    for(j=1;j<=N;j++) dists+=dist[j-1];
    putnums=gettotalputnums(snd,format,dist,N);
    putheader(outfile,&snd[0],putnums*dists,ch0,format,N);
    putoutconmix(infile,outfile,snd,format,putnums,lv,dist,ch0,N);
    return 0;
}

/* sampling rate  N ܤˤʤȤʤ
 */
void putheader(FILE *outfile,SNDheader *snd,long int blocks,int ch,int format,
	       int N)
{
    SNDheader snd1;
    double smplrate=SNDsmplrate(snd,format);

    if(cpSNDheader(&snd1,snd,format)<0) return;
    switch(format){
    case E_AU: snd1.au.channel=ch; break;
    case E_WAV: snd1.wav.channel=ch; break;
    case E_AIFF: snd1.aiff.channel=ch; break;
    default: return;
    }
    putSNDheaderBlocksSmplrate(outfile,&snd1,blocks,smplrate*N,format);
}

void putoutconmix(FILE *infile[],FILE *outfile,SNDheader snd[],int format,
		  int putnums,double lv[],int dist[],int ch0,int N)
{
    long int j,blocks[N];
    int k,nums,dists;

    for(k=1;k<=N;k++) blocks[k-1]=SNDblocks(&snd[k-1],format);
    for(nums=1;nums<=putnums;nums++)
      for(k=1;k<=N;k++)
	for(j=1;j<=dist[k-1];j++)
	  if(blocks[k-1]-->0)
	    put1blocks(infile[k-1],outfile,&snd[k-1],format,lv[k-1],ch0);
	  else SNDputnull1ch(outfile,snd,format);
    dists=0;
    for(j=1;j<=N;j++) dists+=dist[j-1];
    if(format!=E_AU && SNDbitpersmpl(&snd[0],format)==8 && ch0%2 
       && putnums%2 && dists%2)
      fputc(0,outfile);
    return;
}

void put1blocks(FILE *infile,FILE *outfile,SNDheader *snd,int format,double lv,
		int ch0)
{
    int ch=SNDchannels(snd,format),m;
    double x;
    
    if(ch0>1 && ch>1 && ch!=ch0) return;
    if(ch0<1 || ch<1) return;
    if(ch0>1 && ch>1){
	for(m=1;m<=ch;m++){
	    x=SNDget1chleveldata(infile,snd,format);
	    SNDput1chleveldata(outfile,x*lv,snd,format);
	}
    }
    else if(ch==1){
	x=SNDget1chleveldata(infile,snd,format);
	for(m=1;m<=ch0;m++) SNDput1chleveldata(outfile,x*lv,snd,format);
    }
    else{ /* ch0==1 && ch>1 */
	x=0.0;
	for(m=1;m<=ch;m++) x+=SNDget1chleveldata(infile,snd,format);
	SNDput1chleveldata(outfile,x*lv,snd,format);
    }	
    return;
}

long int gettotalputnums(SNDheader snd[],int format,int dist[],int N)
{
    long int blocks,m,max=0L;
    int j;

    for(j=1;j<=N;j++){
	blocks=SNDblocks(&snd[j-1],format);
	m=blocks/dist[j-1];
	if(blocks%dist[j-1]) m++;
	if(m>max) max=m;
    }
    return max;
}

int getchannel(SNDheader snd[],int format,int N)
{
    int ch,ch0=-1,j;

    if(N<=0) return -1;
    if((ch=SNDchannels(&snd[0],format))>1) ch0=ch;
    for(j=2;j<=N;j++)
      if((ch=SNDchannels(&snd[j-1],format))>1){
	  if(ch0>0){ if(ch!=ch0) return -2; }
	  else ch0=ch;
      }
    return (ch0<0)? 1:ch0;
}

int getallheader(FILE *infile[],SNDheader snd[],double lv[],int isv[],int N,
		 int mc)
{
    int j,format,ret;
    int mask = CH_MAGIC|CH_FMCODE|CH_SMPLRATE|CH_BITPERSMPL;
    double level;

    if((format=getSNDheader(infile[0],&snd[0]))<0 || format==E_UNKNOWN){
        fprintf(stderr,"get header error (%d:%d)\n",1,format);
        return -1;
    }
    if(!isv[0]){
	if((level=getmaxlevelCh(infile[0],&snd[0],format,mc))<=0.0) return -2;
	lv[0]/=level;
	isv[0]=1;
	fseek(infile[0],SNDhlen(snd,format),SEEK_SET);
    }
    for(j=2;j<=N;j++){
	if((ret=getSNDheader(infile[j-1],&snd[j-1]))!=format){
	    fprintf(stderr,"get header error (%d:%d)\n",j,ret);
	    return -1;
	}
	if((ret=SNDchheaderMASK(&snd[0],&snd[j-1],format,mask))<0){
	    fprintf(stderr,"Headers are different type.\n");
	    return -4;
	}
	if(!isv[j-1]){
	    if((level=getmaxlevelCh(infile[j-1],&snd[j-1],format,mc))<=0.0) 
	      return -2;
	    lv[j-1]/=level;
	    isv[j-1]=1;
	    fseek(infile[j-1],SNDhlen(snd,format),SEEK_SET);
	}
    }
    return format;
}

/* mc==0: 1ch  mix, mc==1: max channel ˳ĥ
 */
double getmaxlevelCh(FILE *infile,SNDheader *snd,int format,int mc)
{
    double maxlevel[Maxchannel],max;
    int ch=SNDchannels(snd,format),j;

    if((mc!=0 && mc!=1)|| ch<=0 || ch>Maxchannel) return -1.0; 
    if(mc || ch==1) return SNDgetmaxlevel(infile,snd,format);
    else{ 
	SNDgetmaxlevelChannel(infile,snd,format,maxlevel);
	max=0.0;
	for(j=1;j<=ch;j++) max+=maxlevel[j-1];
	return max;
    }
}

int getarg(int argc,char *argv[],FILE **outfile,FILE *infile[],int *mc,
	  double lv[],int isv[],int dist[])
{
    int N=0,j,dg=-1,isd=0;
    double lg=-1.0,vg=-1.0;
   
    *mc=1;
    *outfile=stdout;

    for(j=1;j<=Maxfiles+1;j++) isv[j-1]=-1;

    while(--argc>0){
	if(**(++argv)=='-'){ /* option */
	    if(!strncmp(*argv,"-o",2)){
                if(*outfile!=stdout) return -3;
                if(*(*argv+=2)=='\0'){ if(--argc<=0) return -4; else argv++; }
                if(!strcmp(*argv,"-")) *outfile=stdout;
                else if((*outfile=fopen(*argv,"w"))==NULL){
                    fprintf(stderr,"File [%s] open error.\n",*argv);
                    return -5;
                }
	    }
	    else if(!strncmp(*argv,"-mc",3)) *mc=1;
	    else if(!strncmp(*argv,"-nmc",4)) *mc=0;
	    else if(!strncmp(*argv,"-dg",3)){
		if(*(*argv+=3)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((dg=atoi(*argv))<=0) return -6;
	    }
	    else if(!strncmp(*argv,"-lg",3)){
		if(*(*argv+=3)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((lg=atof(*argv))<=0.0 || lg>1.0) return -7;
	    }
	    else if(!strncmp(*argv,"-vg",3)){
		if(*(*argv+=3)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((vg=atof(*argv))<=0.0) return -8;
	    }
	    else if(!strncmp(*argv,"-d",2)){
		if(*(*argv+=2)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((dist[N]=atoi(*argv))<=0) return -9;
		isd=1;
	    }
	    else if(!strncmp(*argv,"-v",2)){
		if(*(*argv+=2)=='\0'){ if(--argc<=0) return -4; else argv++; }
		isv[N]=1;
		if((lv[N]=atof(*argv))<=0.0) return -9;
	    }
	    else if(!strncmp(*argv,"-l",2)){
		if(*(*argv+=2)=='\0'){ if(--argc<=0) return -4; else argv++; }
		isv[N]=0;
		if((lv[N]=atof(*argv))<=0.0 || lv[N]>1.0) return -10;
	    }
	    else if(*(++*argv)=='h' || **argv=='H' || **argv=='?') return 0;
	    else return -1;
	}
	else{ /* file */
	    if(++N>Maxfiles) return -11;
	    if((infile[N-1]=fopen(*argv,"r"))==NULL){
		fprintf(stderr,"File [%s] open error.\n",*argv);
		return -12;
	    }
	    if(isv[N-1]<0){
		if(vg>0.0){ isv[N-1]=1; lv[N-1]=vg; }
		else if(lg>0.0){ isv[N-1]=0; lv[N-1]=lg; }
		else if(N>=2){ isv[N-1]=isv[N-2]; lv[N-1]=lv[N-2]; }
		else{ isv[N-1]=1; lv[N-1]=1.0; }
	    }
	    if(isd==0){
		if(dg>0) dist[N-1]=dg;
		else if(N>=2) dist[N-1]=dist[N-2];
		else dist[N-1]=1;
	    }
	    else isd=0;
	}
    }
    return N;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndconmix [option] [file1] ([option]) [file2] (...)",
	" [option]:",
	"  global option:",
	"   -o [outfile]: ϥեλ (default: ɸ)",
	"   -mc/-nmc: ǡκͥ/Υ (default: -mc)",
	"   -dg[x]: ֥å¤٤뤫λ (default: 1)",
	"   -vg[x]: ϥեΨ (0.0<[x])",
	"   -lg[x]: ϥեΥ٥ (0.0<[x]<=1.0)",
	"  ե option:",
	"   -d[x]: ³¤٤֥åλ ([x]>=1) (default: 1)",
	"   -v[x]: volume Ψ (0.0<[x]) (default: 1.0)",
	"   -l[x]: volume ٥ (0.0<[x]<1.0) (default: 1.0)",
	"",
	" [1] sndmix Ȥϰۤʤꡢ[file1],[file2](,...) ΥǡûΤ",
	"     Ϥʤ֥å (default: 1) ˻ꤷեΥǡ",
	"     ¤٤ΤϤ롣㤨",
	"       sndconmix -dg2 file1 file2 file3",
	"     νϤϡ",
	"       file1  1 block , file1  2 block ܡ",
	"       file2  1 block , file2  2 block ܡ",
	"       file3  1 block , file3  2 block ܡ",
	"       file1  3 block , file1  4 block ܡ",
	"       ...",
	"     Τ褦ˤʤ롣smpling rate ϡΥǡΥեܤˤ롣",
	" [2] ĤΥե뤫顢ϤȤʤեˤϡsndsmpl ",
	"     sndsubstr Ȥк뤳ȤǤ롣㤨С"
	"       sndsmpl -d 3 file1 > file2",
	"       sndsubstr 1 file1 | sndsmpl -d 3 > file3",
	"       sndsubstr 2 file1 | sndsmpl -d 3 > file4",
	"       sndconmix file2 file3 file4 > file5",
	"     Ȥ file1  file5 ƱΤˤʤ (̩ˤϡfile5 κǸ",
	"      null ǡɲäǽΤǴƱǤϤʤ)",
	" [3] -v[x] ϡƥǡ volume  [x] ܤˤ (cf. sndvol)",
	"     -l[x] ϡƥǡ volume level  [x] ˤ (cf. sndnormal)",
	"     -lg[x]/-vg[x] λϡƤΥեŬѤ롣",
	"     -v[x]/-l[x] ϡƥǡˤɤ餫Τ߻ꤹ롣",
	" [4] -v[x]/-l[x] λϥե֥ץǡƥե",
	"     եˤĤ뤳ȤǤ롣ץ󤬤ĤƤʤե",
	"     ϡ-lg[x]/-vg[x] ʤϤΥե",
	"     롣㤨",
	"       sndconmix  -v0.5 file1 -l0.3 file2 file3",
	"     ξϡfile1  0.5 ܤǡfile2  file3  level 0.3 ǡ",
	"       sndconmix -vg0.5 file1 -l0.3 file2 file3",
	"     ξϡfile1  file3  0.5 ܤǡfile2  level 0.3 ",
	"     뤳Ȥˤʤ (-vg  global option)", 
	" [5] ʣ channel Υǡ channel ˹뤬channel ",
	"     ΰۤʤǡƱΤι -mc/-nmc ץˤäơ",
	"     channel ˹碌뤫 1 channel ˤ뤫Ǥ (default",
	"     Ϻ) -mc Ϻ channel ñ channel  2 ",
	"      channel ΥǡΤߤꤵƤ˵ǽ",
	"     ʳξ (㤨 2 channel  4 channel Υǡ 1,2,3  3",
	"      channel Υǡ) ϥ顼Ȥʤ롣", 
	" [6] -v λϡߤ channel ˤĤ뤳ȤϤǤʤΤǡ",
	"     channel  level ѹϡ餫ϥե",
	"      level  channel ĴᤷƤ (cf. sndvol) ϥ",
	"      level  channel Ĵ᤹ (cf. sndvol) ȡ",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
