/* ȿñ㲻ġ
 * shige
 * 02/28 2001
 * wavhz.c
 *
 * $Id: wavhz.c,v 1.4 2002-02-19 23:21:04+09 shige Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifdef __hpux
# include <values.h>
#endif
#include "wavio.h"

#define POS8bit 127
#define SCALE8bit 125.0
#define POS16bit 0
#define SCALE16bit 32764.0
#define USESINEWAVE

int main(int argc,char *argv[]);
void putsound(FILE *outfile,WAVdata *wd,int hz,double vol);
double periodic(double x);
void usage(void);

int main(int argc,char *argv[])
{
    FILE *outfile=stdout;
    int hz,len,sample,ch,bit;
    double vol;
    WAVdata wd;
    int blocks;

    if(argc!=6+1 ||(hz=atoi(argv[1]))<0
       ||(len=atoi(argv[2]))<=0
       ||(vol=atof(argv[3]))<0.0 || vol>1.0
       ||(sample=atoi(argv[4]))<=0
       ||((ch=atoi(argv[5]))!=1 && ch!=2)
       ||((bit=atoi(argv[6]))!=8 && bit!=16)){
	usage();
	return 0;
    }
    wd.fmcode=1; /* linear PCM */
    wd.channel=ch;
    wd.smplrate=sample;
    wd.bitpersmpl=bit;
    wd.blocksize=bit*ch/8;
    wd.bytepersec=wd.blocksize*sample;
    blocks=(int)((double)len*sample/1000.0+0.5);
    wd.datalen=blocks*wd.blocksize;
    putsound(outfile,&wd,hz,vol);
    return 0;
}

/* hz Hz, len ߥäβ volume level vol ή
 * hz == 0 ==> ̵
 */
void putsound(FILE *outfile,WAVdata *wd,int hz,double vol)
{
    int j,blocks,k;
    unsigned char c;
    short int y;

    putallWAVheader(outfile,wd,1);
    if(hz==0 || vol==0.0){
	if(wd->bitpersmpl==8){
	    for(j=1;j<=wd->datalen;j++) fputc(WAV8NULL,outfile);
	    if(wd->datalen%2) fputc('\0',outfile);
	}
	else
	  for(j=1;j<=wd->datalen/2;j++) 
	    writelittleito2byte(outfile,WAV16NULL);
    }
    else{
	blocks=wd->datalen/wd->blocksize;
	if(wd->bitpersmpl==8){
	    for(j=1;j<=blocks;j++){
		c=vol*periodic((double)j*hz/wd->smplrate)*SCALE8bit+POS8bit;
		for(k=1;k<=wd->channel;k++) 
		  fputc(c,outfile);
	    }
	    if(wd->datalen%2) fputc('\0',outfile);
	}
	else{
	    for(j=1;j<=blocks;j++){
		y=vol*periodic((double)j*hz/wd->smplrate)*SCALE16bit+POS16bit;
		for(k=1;k<=wd->channel;k++) 
		  writelittleito2byte(outfile,y);
	    }
	}
    }
}

#ifdef USESINEWAVE
/*  1,  -1.0~1.0
 */
double periodic(double x)
{
    return sin(2.0*M_PI*x);
}
#else
double periodic(double x)
{
    int j;

    j=x;
    return x-j;
}
#endif

void usage(void)
{
    char *mess[]={
	"Usage: wavhz [Hz] [msec] [vol] [smpl] [ch] [bit] (> [newfile])",
	" [Hz]  : ñ㲻ι⤵   (ȿ)",
	" [msec]: ñ㲻Ĺ   (ߥ)",
	" [vol] : ñ㲻礭 (0.0~1.0)",
	" [smpl]: WAV եΥץ󥰼ȿ (44100(Hz) ʤ)",
	" [ch]  : WAV եΥͥ (1(Υ), 2(ƥ쥪))",
	" [bit] : WAV ե bit Ĺ (8, 16)",
	"Ex. wavhz 440 500 0.7 44100 1 16 > poo.wav",
	" ==> 440Hz (), 0.5 äβ򥵥ץ󥰼ȿ 44100Hz,",
	"     Υ, ̻Ҳӥå 16bit Ǻ",
	" 1) Ϥɸϡ",
	" 2) [Hz] == 0 ޤ [vol] == 0 Ȥ̵Υǡ롣",
#ifdef USESINEWAVE
	" 3) ñ㲻ϻȤѤ롣",
#else
	" 3) ñ㲻ϥΥȤѤ롣",
#endif
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}
